Bug 694994 - Review Request: yoshimi - Rewrite of ZynAddSubFx aiming for better JACK support
Review Request: yoshimi - Rewrite of ZynAddSubFx aiming for better JACK support
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Brendan Jones
Fedora Extras Quality Assurance
:
Depends On:
Blocks: FedoraAudio
  Show dependency treegraph
 
Reported: 2011-04-09 10:00 EDT by Adam Huffman
Modified: 2015-07-04 02:01 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-07-04 02:01:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
brendan.jones.it: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Patch to fix link error with fltk-1.3 (1.93 KB, patch)
2011-08-28 05:36 EDT, Brendan Jones
no flags Details | Diff
Patch to build 1.0.0 (1.38 KB, patch)
2012-10-29 01:49 EDT, Brendan Jones
no flags Details | Diff

  None (edit)
Description Adam Huffman 2011-04-09 10:00:21 EDT
Spec URL: http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi.spec
SRPM URL: http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi-0.060.8-1.fc14.src.rpm
Description: 
Yoshimi is a rewrite of ZynAddSubFx to improve its compatibility with
the Jack Audio Connection Kit.

ZynAddSubFX is an open source software synthesizer capable of making a
countless number of instrument sounds. It is microtonal, and the instruments
made by it sounds like those from professional keyboards. The program has
effects like Reverb, Echo, Chorus, Phaser...
Comment 1 Adam Huffman 2011-04-09 10:08:39 EDT
rpmlint output:


yoshimi.src: W: spelling-error %description -l en_US microtonal -> micro tonal, micro-tonal, microtone
The value of this tag appears to be misspelled. Please double-check.

yoshimi.x86_64: W: spelling-error %description -l en_US microtonal -> micro tonal, micro-tonal, microtone
The value of this tag appears to be misspelled. Please double-check.

yoshimi.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

yoshimi.x86_64: W: hidden-file-or-dir /usr/share/yoshimi/banks/chip/.bankdir
The file or directory is hidden. You should see if this is normal, and delete
it from the package if not.

yoshimi.x86_64: E: zero-length /usr/share/yoshimi/banks/chip/.bankdir
yoshimi.x86_64: W: no-manual-page-for-binary yoshimi
Each executable in standard binary directories should have a man page.

3 packages and 1 specfiles checked; 1 errors, 5 warnings.

I believe the .bankdir file is needed, but will remove it if not.
Comment 2 Brendan Jones 2011-04-09 23:35:27 EDT
Hi Adam,

thanks for packaging this. Here's an informal review:

+ OK
- N/A
! Problem
? Not evaluated

fedora15:/home/Documents$ rpmlint /var/lib/mock/fedora-15-x86_64/result/yoshimi-0.060.8-1.fc15.src.rpm 
yoshimi.src: W: spelling-error %description -l en_US microtonal -> micro tonal, micro-tonal, microbial
1 packages and 0 specfiles checked; 0 errors, 1 warnings.


Required
========

[+] named according to the Package Naming Guidelines 
[+] The spec file name must match the base package %{name}, in the format
%{name}.spec 
[+] Meet the Packaging Guidelines
    *** (optional): no longer need %clean/cleaning of the buildroot in %install
unless building for F12 and below  or EPEL   
[+] Be licensed with a Fedora approved license and meet the Licensing
Guidelines 
[!] The License field in the package spec file must match the actual license 
 *** source includes header comments from ZynAddSubFX stating GPLv2+
[!] License file must be included in %doc
 *** COPYING file must be included in %doc, as well ass 0.60.8.notes
[+] The spec file must be written in American English
[+] The spec file for the package MUST be legible
[+] The sources used to build the package must match the upstream source
[+] Successfully compile and build into binary rpms on at least one primary
architecture
[-] Proper use of ExcludeArch 
[+] All build dependencies must be listed in BuildRequires
 *** consider adding hicolor-icon-theme to Requires
[+] The spec file MUST handle locales properly
[-] Shared library files (not just symlinks) in any of the dynamic linker's
default paths, must call ldconfig in %post and %postun
[+] Packages must NOT bundle copies of system libraries
[-] If the package is designed to be relocatable, the packager must state this
fact in the request for review, along with the rationalization for relocation
of that specific package
[+] A package must own all directories that it creates
directories under this
[!] A Fedora package must not list a file more than once in the spec file's
%files listings
 *** You only require  %{_datadir}/%{name} - it encompasses sub-directories
[+] Permissions on files must be set properly. Every %files section must
include a %defattr(...) line
[+] Each package must consistently use macros
[+] The package must contain code, or permissable content
[-] Large documentation files must go in a -doc subpackage
[+] If a package includes something as %doc, it must not affect the runtime of
the application
[-] Header files must be in a -devel package
[-] Static libraries must be in a -static package
[-] library files that end in .so (without suffix) must go in a -devel package
[-] devel packages must require the base package using a fully versioned
dependency
[-] Packages must NOT contain any .la libtool archives
[!] GUI apps must include a %{name}.desktop file, properly installed with
desktop-file-install in the %install section 
 *** Gnome uses "Comment" whereas KDE uses "GenericName". Should these be the same?
[+] Packages must not own files or directories already owned by other packages
[+] All filenames in rpm packages must be valid UTF-8

Should Items
============
[-] the packager SHOULD query upstream for any missing license text files to
include it
[-] Non-English language support for description and summary sections in the
package spec if available
[-] The reviewer should test that the package builds in mock
[-] The package should compile and build into binary rpms on all supported
architectures
[+] The reviewer should test that the package functions as described
[+] If scriptlets are used, those scriptlets must be sane
[-] Usually, subpackages other than devel should require the base package using
a fully versioned dependency
[-] The placement of pkgconfig(.pc) should usually be placed in a -devel pkg
[-] If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself
[-] Should contain man pages for binaries/scripts
    *** no man pages in upstream package
Comment 3 Martin Gieseking 2011-04-10 03:12:59 EDT
> [!] The License field in the package spec file must match the actual license 
>  *** source includes header comments from ZynAddSubFX stating GPLv2+

The license situation is indeed pretty unclear here:
- files in src/DSP: licensed under GPLv2 only
- files in src/MusicIO and src/main.c: licensed under GPLv3+

Since GPLv2 and GPLv3+ are incompatible, the package can't be distributed this way. Adam, you should ask upstream to clarify the license and to update the copyright info in the source files accordingly.


> [!] A Fedora package must not list a file more than once in the spec file's
> %files listings
>  *** You only require  %{_datadir}/%{name} - it encompasses sub-directories

Listing %{_datadir}/%{name}/banks/ and %{_datadir}/%{name}/presets/ separately is fine. %{_datadir}/%{name}/ would also be valid but has no advantages over the more explicit variant. Actually, being more explicit is usually better and might prevent packaging of unwanted files.


> [!] GUI apps must include a %{name}.desktop file, properly installed with
> desktop-file-install in the %install section 
>  *** Gnome uses "Comment" whereas KDE uses "GenericName". Should these be the
> same?

No. According to the desktop file spec (http://standards.freedesktop.org/desktop-entry-spec/latest/ar01s05.html), GenericName should describe the type of the application while Comment contains a toolip text. The spec says: "The value [of Comment] should not be redundant with the values of Name and GenericName." This wouldn't be a blocker, though.
Comment 4 Adam Huffman 2011-04-10 08:31:40 EDT
Thanks for taking a look.  New version including the doc files available at:

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi.spec

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi-0.060.8-2.fc14.src.rpm

I've posted a message to the yoshimi-user list asking about the clashing licences.

There is actually a desktop file that comes with it (I used one from Niels Mayer) with the following in those two fields:


Comment=Real Time Synthesizer
GenericName=Synthesizer

There's also a different icon file, which I might switch to (again in place of Niels' version).
Comment 5 Adam Huffman 2011-04-10 18:48:44 EDT
It appears the licence for the files derived from ZynAddSubFx should in fact be GPLv2 or later, as they were relicenced in 2007.  Once there's a new upstream release with this change, I'll update my RPM.
Comment 6 Adam Huffman 2011-04-11 16:39:34 EDT
New version incorporating latest upstream release which clarifies the licencing position (now GPLv2 or later) at:

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi.spec

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi-0.060.9-1.fc14.src.rpm
Comment 7 Martin Gieseking 2011-04-11 17:01:41 EDT
Thanks for clarifying the license issue. 
However, there are still some files under GPLv3+, so the resulting binary is under GPLv3+ as well (GPLv2+ and GPLv3+ = GPLv3+). Therefore, file COPYING should also contain the GPLv3 license text (currently still GPLv2). The latter isn't a blocker though, but please don't add COPYING to the package as long as it contains the wrong license text.
Comment 8 Adam Huffman 2011-04-11 17:27:26 EDT
I should notify upstream about this then?
Comment 9 Brendan Jones 2011-04-11 17:51:19 EDT
I've noticed Ubuntu packages this with a GPLv2+ with exceptions, the exceptions being all those file which are GPLv3. Not sure if this is correct or indeed any help here.
Comment 10 Martin Gieseking 2011-04-12 02:50:51 EDT
(In reply to comment #8)
> I should notify upstream about this then?

Yes, that would be nice. As long as the tarball is in its current state, just update the License field and drop COPYING for now. Once a new tarball with corrected license text is available, readd it.

(In reply to comment #9)
> I've noticed Ubuntu packages this with a GPLv2+ with exceptions, the exceptions
> being all those file which are GPLv3. Not sure if this is correct or indeed any
> help here.

Unfortunately, I'm not familiar with the Ubuntu guidelines, but I doubt "GPLv2+ with exceptions" is correct. GPLv3+ is compatible with but more restrictive than GPLv2+. Since both licenses are part of the generated binary, we have to find the "intersection" of them. GPLv2+ intersected with GPLv3+ is GPLv3+ as the latter is some kind of "subset" of GPLv2+.
"GPLv2+ with exceptions" is reserved for special GPLv2+ variants with exception clauses in the source headers. See here: http://fedoraproject.org/wiki/Licensing#SoftwareLicenses

Sorry Brendan, I didn't intend to hijack this ticket. If you'd like to do the formal review, please do so. :)
Comment 11 Brendan Jones 2011-04-12 03:04:59 EDT
No problem Martin, my knowledge of the GPL is not that crash hot. I'll defer to you on this one!
Comment 12 Adam Huffman 2011-04-17 13:39:08 EDT
New version with latest upstream which includes GPLv2 and v3 licence text in COPYING:

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi.spec

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi-0.060.10-1.fc14.src.rpm
Comment 13 Brendan Jones 2011-06-02 17:32:40 EDT
Hi Adam

I'll complete this for you. Before I complete the full review two things came up in rpmlint:

rpmlint /home/bsjones/rpmbuild/SRPMS/yoshimi-0.060.10-1.fc15.src.rpm

yoshimi.src: W: spelling-error %description -l en_US microtonal -> micro tonal, micro-tonal, microbial
yoshimi.src: W: strange-permission yoshimi.desktop 0764L
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

rpmlint /var/lib/mock/fedora-15-x86_64/result/yoshimi-0.060.10-1.fc15.x86_64.rpm
yoshimi.x86_64: W: spelling-error %description -l en_US microtonal -> micro tonal, micro-tonal, microbial
yoshimi.x86_64: W: hidden-file-or-dir /usr/share/yoshimi/banks/chip/.bankdir
yoshimi.x86_64: E: zero-length /usr/share/yoshimi/banks/chip/.bankdir
yoshimi.x86_64: E: non-executable-script /usr/share/applications/yoshimi.desktop 0644L /usr/bin/env
yoshimi.x86_64: W: no-manual-page-for-binary yoshimi
1 packages and 0 specfiles checked; 2 errors, 3 warnings.
Comment 14 Adam Huffman 2011-06-08 18:48:31 EDT
Brendan,

Thanks for taking this on.  I wasn't quite sure what to do about the .bankdir file - is it necessary for yoshimi to use preset banks properly?  So, I'll contact upstream about it.  I will fix the second error too.
Comment 15 Brendan Jones 2011-08-28 05:35:04 EDT
Hi Adam,

I was rebuilding this for rawhide and found that it failed with fltk-1.3. I'll attach a patch for this.

Also, there is talk of a merge back with zyn given Cal's passing - not sure if you are aware of this. If not you might want to check with both project's developer lists for an update.

Let me know if/when you want me to proceed with the review as its pretty much there.

Brendan
Comment 16 Brendan Jones 2011-08-28 05:36:09 EDT
Created attachment 520210 [details]
Patch to fix link error with fltk-1.3
Comment 17 Adam Huffman 2011-08-29 17:47:49 EDT
Brendan,

Many thanks for the patch, which I've applied to my local git repo.

I am on the mailing list and I've been following recent developments.

Will probably be next week before I can spend sufficient time on this - I'll send an update then.

Adam
Comment 18 Adam Huffman 2012-01-08 07:32:47 EST
I'll upload a new version with the latest upstream changes later today.
Comment 20 Brendan Jones 2012-01-28 14:19:18 EST
Sorry Adam, missed this completely. Only remembered your review just when I was about to recommend a patch upstream. Will finish this by the end of the weekend.

(you can always ping me if you haven't had a response in due course - I tend to use a 7 day rule)

cheers
Comment 21 Brendan Jones 2012-02-02 08:24:55 EST
Hi Adam,

there's now a desktop icon file shipped with the tarrball that you can use. Also a desktop file that gets installed to. You may need to modify it for Fedora Multimedia menu categories with desktop-file-install

You also can pull the patch from the SRPM as it is no longer required.

regards,

Brendan
Comment 22 Brendan Jones 2012-02-19 08:05:29 EST
Adam, I can take over this one if you would like?
Comment 23 Adam Huffman 2012-02-19 11:54:10 EST
Brendan,

Apologies for the delay.

There's a new version at:

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi.spec
http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi-0.060.12-2.fc16.src.rpm

Having a bit of trouble using the new desktop file.  I tried replacing the placeholders for Yoshimi version and the prefix in the spec, but it's clearly not working properly because the desktop-file-install invocation is failing, indicating that it's checking the original version.
Comment 24 Brendan Jones 2012-02-19 12:13:39 EST
Aplogies, upstream has not packaged the .desktop file correctly (nothing in CmakeLists.txt for the desktop file - looks like the .desktop file was committed as a guide by someone who did not know how to integrate it into the build system)

Ship your original .desktop file, but use their icon
Comment 25 Adam Huffman 2012-02-20 09:08:35 EST
Okay, so I wasn't going mad when I couldn't find any reference to the .desktop file in the CMake scripts then...

New version, with my .desktop file reinstated and using the upstream icon:

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi.spec

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi-0.060.12-3.fc16.src.rpm
Comment 26 Brendan Jones 2012-02-20 09:29:56 EST
Cool, almost there, Just remove the .bankdir from /usr/share/yoshimi/banks/chip/
Comment 27 Adam Huffman 2012-02-20 16:32:15 EST
That should be fixed now, I haven't incremented the release number for such a minor change, so it's available at the same links.
Comment 28 Brendan Jones 2012-03-06 15:25:09 EST
[+] OK
[!] NEEDS ATTENTION
[-] NOT APPLICABLE

Required
========

[+] named according to the Package Naming Guidelines 
[+] The spec file name must match the base package %{name}, in the format
%{name}.spec 
[!] Meet the Packaging Guidelines  
[+] Be licensed with a Fedora approved license and meet the Licensing
Guidelines 
[+] The License field in the package spec file must match the actual license 
[+] License file must be included in %doc
[+] The spec file must be written in American English
[+] The spec file for the package MUST be legible
[+] The sources used to build the package must match the upstream source
e5c7dfb0d655083b9c84b6a67d1a8cd4 ok
[+] Successfully compile and build into binary rpms on at least one primary
architecture
[+] Proper use of ExcludeArch 
[+] All build dependencies must be listed in BuildRequires
[+] The spec file MUST handle locales properly
[+] Shared library files (not just symlinks) in any of the dynamic linker's
default paths, must call ldconfig in %post and %postun
[+] Packages must NOT bundle copies of system libraries
[-] If the package is designed to be relocatable, the packager must state this
fact in the request for review, along with the rationalization for relocation
of that specific package
[+] A package must own all directories that it creates
directories under this
[+ ] A Fedora package must not list a file more than once in the spec file's
%files listings
[+] Permissions on files must be set properly.
[+] Each package must consistently use macros
[+] The package must contain code, or permissable content
[-] Large documentation files must go in a -doc subpackage
[+] If a package includes something as %doc, it must not affect the runtime of
the application
[-] Header files must be in a -devel package
[-] Static libraries must be in a -static package
[-] library files that end in .so (without suffix) must go in a -devel package
[-] devel packages must require the base package using a fully versioned
dependency
[+] Packages must NOT contain any .la libtool archives
[+] GUI apps must include a %{name}.desktop file, properly installed with
desktop-file-install in the %install section 
[+] Packages must not own files or directories already owned by other packages
[+] All filenames in rpm packages must be valid UTF-8

Should Items
============
[-] the packager SHOULD query upstream for any missing license text files to
include it
[-] Non-English language support for description and summary sections in the
package spec if available
[+] The reviewer should test that the package builds in mock
[-] The package should compile and build into binary rpms on all supported
architectures
[+] The reviewer should test that the package functions as described
[!] If scriptlets are used, those scriptlets must be sane
See below
[-] Usually, subpackages other than devel should require the base package using
a fully versioned dependency
[-] The placement of pkgconfig(.pc) should usually be placed in a -devel pkg
[-] If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself
[-] Should contain man pages for binaries/scripts


Action items (MUST):

Need to remove the deprecated defattr, %clean and rm -rf %buildroot sections.

Need to add the %posttrans scriptlet:

%posttrans
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :

Apart from that this is ready.
Comment 29 Brendan Jones 2012-04-11 13:24:30 EDT
Adam, this is as good as APPROVED, Can yoou please action this?

This is being tracked by the Fedora Audio spin now.

Brendan
Comment 30 Adam Huffman 2012-04-11 15:03:45 EDT
Will take a look this weekend.
Comment 31 Adam Huffman 2012-04-15 17:56:29 EDT
I would like to build this for EPEL5/6 if possible, so I'd prefer to keep the deprecated parts in.  Once it's in Fedora, I'll only put them in the relevant branches.

I've added the missing scriptlet.  There is now a new rpmlint complaint:


yoshimi-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/yoshimi-0.060.12/src/DSP/Unison.h
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

Slightly odd that it would only show up in the debuginfo package.  I'll check into it and report to the yoshimi list if necessary.

New version at:

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi.spec

http://verdurin.fedorapeople.org/reviews/yoshimi/yoshimi-0.060.12-4.fc16.src.rpm
Comment 32 Brendan Jones 2012-07-04 05:06:36 EDT
That's fine Adam. APPROVED.

I believe version 1.0 is imminent
Comment 33 Adam Huffman 2012-07-04 09:16:28 EDT
New Package SCM Request
=======================
Package Name: yoshimi
Short Description: Rewrite of ZynAddSubFx aiming for better JACK support
Owners: verdurin
Branches: f16 f17 el5 el6
Comment 34 Jon Ciesla 2012-07-04 16:57:46 EDT
Git done (by process-git-requests).
Comment 35 Brendan Jones 2012-10-27 07:24:27 EDT
Hi Adam

can you please submit a build? thanks
Comment 36 Adam Huffman 2012-10-28 18:28:13 EDT
Hi Brendan,

I did try scratch builds a few weeks ago and there was a problem with the detection of FLTK.  The problem's still there, so I'll look into fixing it this coming week.  I'll also update to the latest upstream source.
Comment 37 Brendan Jones 2012-10-29 01:49:02 EDT
Created attachment 634878 [details]
Patch to build 1.0.0
Comment 38 Adam Huffman 2012-10-29 08:24:23 EDT
(In reply to comment #37)
> Created attachment 634878 [details]
> Patch to build 1.0.0

Hi Brendan,

Thanks for the patch.  Unfortunately, it's still not building, so I'll have to look at this further.
Comment 39 Brendan Jones 2012-10-29 16:18:09 EDT
You can see from the output that RLTK is looking for libGL.so
Comment 40 Brendan Jones 2012-10-29 16:18:49 EDT
(In reply to comment #39)
> You can see from the output that FLTK is looking for libGL.so

Try BuildRequires: mesa-libGL-devel
Comment 41 Adam Huffman 2015-07-04 02:01:55 EDT
This has been building for a long time now, but I forgot to close the review ticket.

Note You need to log in before you can comment on or make changes to this bug.